/* This is a simple decimal number to two's compliment function that could be used universally for
   other NetBurner applications where Maths is involved*/
// However this simple function will later become more complex as described below:-
// Part of Shinko Temperature Controller CRC-checking Protocol for NetBurner - Written by Paul Bellett Copyright 2009 */
// Contact :- www.microwebserver.net email:- enquiry@microwebserver.net */
// This function will be later incorporated into a serial ASCII 15 byte frame command (included are two bytes or 16 bits for CRC checking)
// Also this code could be morphed later sometime in the future into the Industry Standard Modbus (ASCII) serial transmission protocol */

// ***************************************************************************//
// Part of support file for a FLASH enabled web client for sending Set Value temperature settings over any
// TCP/IP Ethernet to Serial
// connected (RS232 or RS485)network.
//************************************************************************************************************
// Ignore #define variables just for now - intended to be used later for NetBurner ASCII serial stream command code for Japanese
// Shinko Temperature Controllers.

#define STX (02h)  // Header ASCII character for start of Shinko Protocol command
#define InstrumentAddress (20h) //The default value address set for a particular instrument (Range can be from 20H to 7FH)
#define SubAddress (20h)// This is instrument address is permanently fixed and does not get changed.
#define SetValue (50h) // Used to set the desired or preferred temperature set point for the controller.
#define ReadTemperature (20h) // Used to retrieve actual room temperature from a remote location
#define SV_Class1 (30h)//Data classification of the command object - Composed of 4 hexidecimal digits (1)
#define SV_Class2 (30h)//Data classification of the command object - Composed of 4 hexadecimal digits (2)
#define SV_Class3 (30h)//Data classification of the command object - Composed of 4 hexadecimal digits (3)
#define SV_Class4 (31h)//Data classification of the command object - Composed of 4 hexadecimal digits (4)
#define ETX // End of text ASCII to terminate transmission of Shinko Protocol command



void CRC_Conversion(short binary, char *pointer) //Calculate a 2's compliment function on a decimal number into binary
	{
	short unsigned mask = 0x8000; // used to check each individual bit, unsigned to alleviate sign extension problems
		 while (mask) // Loop indefinately until MASK is empty
    {
    // Calculate 1's compliment: Reverse each binary bit. 0 will become 1 and viceaversa
			 if (binary & mask)     // test the masked bit
           *pointer = '1';   // if condition is true, value is 1
			 else
          *pointer = '0';   // if condition is false, value is 0
       // Increment by adding a binary one to 1's compliment making it 2's compliment
           pointer++;              // next character
           mask >>= 1;         // shift the mask 1 bit
    }

    *pointer = 0;               // add a trailing null number
	}

