#include "predef.h" //The NB Application wizard automatically takes care of what header files to include for this application
#include <stdio.h> // ""
#include <ctype.h> //""
#include <startnet.h> // ""
#include <autoupdate.h> //""
#include <dhcpclient.h> //""

// 21 September 2009
// Written by Paul Bellett (Kiwinet - http://microwebserver.net) for the SB70 Development kit,
// however it should also universally work for other model NetBurner modules.
// To comply fully with the NetBurner licensing conditions it must run on NetBurner Hardware.

extern "C"
{ 	// Tells complier to avoid mangling of both versions using C & C++ code.
void UserMain(void * pd);
}

/* UserMain()is used as the starting function
- Function parses arguments {pointer data(*pd)} to initialize the timer and serial port
from NetBurner Library in lieu of using 'Main' function which is directly invoked by the RTOS to do all the system initialization.
N.B. The RTOS, or uC Real-Time Operating System is already set up by default, it is the glue that makes every task run smoothly;
For this particular case, Two's Compliment function is a non critical timing task run under the umbrella of the UserMain loop. */

extern void CRC_Conversion(short binary , char *pointer); // declare function type to the fussy C compiler
const char * AppName="CRC_TwosCompliment"; //Lets the PC autoupdate tool see what NB application is currently running

void UserMain(void * pd) {
    InitializeStack(); // I used the NetBurner Eclipse Network Setup Wizard to list this TCP/IP function
    if (EthernetIP == 0) GetDHCPAddress(); // Autodetect the NetBurner IP address on the Network
    OSChangePrio(MAIN_PRIO); //Set the UserMain loop task to a priority of 50 in the RTOS
    EnableAutoUpdate(); // // Enable any program Update revisions using the PC AutoUpdate tool application.

        short		number;  // short integer variable for our calculated number
    	short		two; //short integer variable for our Two's compliment output
    	char		binary[20]; // Max Array size allocation for our binary output number

    	number = 5270 ; 	//<< Our arbitrary decimal test number goes here, some strange NetBurner model number will do for this example:-)
    	two = ~number;		//Unary bitwise complement operator for One's compliment 0 to 1 and 1 to 0
    	two = two + 1;		//Two's compliment

    	iprintf("Two's Compliment Application started\n"); // Message read through RS232 Serial #0 Debug Port */
    	iprintf("Original decimal and hexadecimal() number is: %hd(%hx)\n",number,number); //As displayed through MTTY or Hyperterminal program
       	iprintf("Negative number is: %hd(%hx)\n",-number,-number);// "" ""

    	CRC_Conversion(number,binary);
    	iprintf("Original Number in binary is: %s\n",binary); // Message read through RS232 Serial #0 Debug Port */

    	CRC_Conversion(two,binary);
    	iprintf("Two's Compliment Number in binary is: %s\n",binary); // Message read through RS232 Serial #0 Debug Port */

    while (1) { //endless true condition loop
        OSTimeDly(20); // Really doesn't do much except for the RTOS-  it maybe more critical later when adding additional tasks to this simple program
    }
}
